/**
 * 
 * Copyright (C) 2001 Alexandre. N. Safiullin <alex_@unis-ru.com> 
 * 
 * The contents of this file are subject to the GNU General Public License
 * Version 2 (the License). You may not copy or use this
 * file, in either source code or executable form, except in compliance
 * with the License.

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

//     In addition, as a special exception, Alexandre N. Safiullin 
//     gives permission to link the code of this program with
//     the JECL (Jabber External Component Library, jabber.tigris.org)
//     (or with modified versions of JECL that use the
//     same license as JECL), and distribute linked combinations including
//     the two.  You must obey the GNU General Public License in all
//     respects for all of the code used other than JECL.  If you modify
//     this file, you may extend this exception to your version of the
//     file, but you are not obligated to do so.  If you do not wish to
//     do so, delete this exception statement from your version.

/* File: MyElement.h -> a part of the "icqv7-t" project 
   Created: Fri Nov 16 01:06:17 2001
		by Alexandre N. Safiullin <alex_@unis-ru.com>
   Contains:  */

#ifndef MyElement_h_
#define MyElement_h_

#include <judo.h>
#include <jax.h>

using namespace jax;
using namespace judo;
using namespace std;

extern "C" {
#include <lib.h>
#include <jabberd.h>
}

class MyElement {
public:
	MyElement(xmlnode);
	MyElement(Packet* p);  // overtake ownership under p,
	~MyElement(); // so deletes p in destructor
	
	ptype getPtype() { return ptyp; }
	unsigned char getType() { return jp->type; }
	
	Element* getElement() { return packet->getElement(); }
   	string toString();

	struct exception {
		class BadElement { } ;
	};
	
	jpacket jp;
	ptype ptyp;
	unsigned char subtype;
private:
	Packet* packet;
	
};


class MyRouterConnection : public RouterConnection<Packet, Packet> {
public:
	void deliver(MyElement* me);
	MyRouterConnection(bedrock::net::SocketWatcher& w,
									   EventListener& el,
									   bool outgoing,
									   unsigned int threadkey);
};

#endif
