/**
 * 
 * Copyright (C) 2001 Alexandre. N. Safiullin <alex_@unis-ru.com> 
 * 
 * The contents of this file are subject to the GNU General Public License
 * Version 2 (the License). You may not copy or use this
 * file, in either source code or executable form, except in compliance
 * with the License.

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

//     In addition, as a special exception, Alexandre N. Safiullin 
//     gives permission to link the code of this program with
//     the JECL (Jabber External Component Library, jabber.tigris.org)
//     (or with modified versions of JECL that use the
//     same license as JECL), and distribute linked combinations including
//     the two.  You must obey the GNU General Public License in all
//     respects for all of the code used other than JECL.  If you modify
//     this file, you may extend this exception to your version of the
//     file, but you are not obligated to do so.  If you do not wish to
//     do so, delete this exception statement from your version.

/* File: SmsTrans.cpp -> a part of the "icqv7-t" project 
   Created: Sat Jan 12 23:47:02 2002
		by Alexandre N. Safiullin <alex_@unislabs.com>
   Contains: implementation of SmsTrans */

#include <SmsTrans.h>

SmsTrans::SmsTrans(const std::string& serviceid, 
			       const std::string& password, 
			       const std::string& hostname, 
			       unsigned int port, bool outgoing_dir,
				   IcqTrans& it) :
	/*	_id(serviceid), */ _tpool(5), _threadkey(-1), _watcher(_tpool,10),
						   _router(_watcher, *this, outgoing_dir, 0),
						   icq_t(it)
{
	/* now time to do standard things: */
    // Connection type (accept/connect)
	t/* <<"ID: "<<_id<<endl */
	 <<"Host: "<<hostname<<endl
	 <<"Port: "<<port<<endl
	 <<"Password: "<<password<<endl;

	Address router_addr(hostname, "_jabber._tcp", port);
	
	_router.connect(serviceid, password, router_addr);
}

SmsTrans::~SmsTrans(){
}


// Router event callbacks
void SmsTrans::onRouterConnected()
{
    t << "SMS-t: Router is now connected." << endl;
}

void SmsTrans::onRouterDisconnected()
{
    t << "SMS-t: Router is now disconnected." << endl;
//    bedrock::Application::stop(1, "SMS-t: Router connection lost");
}

void SmsTrans::onRouterError()
{
    t << "SMS-t: Router error occurred." << endl;
    _router.disconnect();
}

void SmsTrans::onRouterPacket(jax::Packet* packet)
{
    t << "SMS-t: Received packet from router: " << packet->toString() << endl;
	icq_t.onRouterPacket(packet);
}
