/**
 * 
 * Copyright (C) 2001 Alexandre. N. Safiullin <alex_@unis-ru.com> 
 * 
 * The contents of this file are subject to the GNU General Public License
 * Version 2 (the License). You may not copy or use this
 * file, in either source code or executable form, except in compliance
 * with the License.

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

//     In addition, as a special exception, Alexandre N. Safiullin 
//     gives permission to link the code of this program with
//     the JECL (Jabber External Component Library, jabber.tigris.org)
//     (or with modified versions of JECL that use the
//     same license as JECL), and distribute linked combinations including
//     the two.  You must obey the GNU General Public License in all
//     respects for all of the code used other than JECL.  If you modify
//     this file, you may extend this exception to your version of the
//     file, but you are not obligated to do so.  If you do not wish to
//     do so, delete this exception statement from your version.

/* File: SmsTrans.h -> a part of the "icqv7-t" project 
   Created: Sat Jan 12 23:35:31 2002
		by Alexandre N. Safiullin <alex_@unislabs.com>
   Contains: SMS subagent headers */

#ifndef SmsTrans_h_
#define SmsTrans_h_

#include <IcqTrans.h>

class SmsTrans : public MyRouterConnection::EventListener {
public:
	SmsTrans(const std::string& serviceid, 
					   const std::string& password, 
					   const std::string& hostname, 
					   unsigned int port, bool outgoing_dir,
			 IcqTrans&);

	~SmsTrans();
	

    // Router event callbacks
    void onRouterConnected();
    void onRouterDisconnected();
    void onRouterError();
    void onRouterPacket(jax::Packet* pkt);
private: 
	
	IcqTrans& icq_t;

    bedrock::ThreadPool _tpool;
	int _threadkey;
	SocketWatcher _watcher;
	RouterConnection<Packet,Packet> _router;
};

#endif
