//============================================================================
// Project:       Bedrock -- Foundational Objects
// Filename:      CondVariable.cpp
// Description:   bedrock::CondVariable implementation
// Created at:    Thu Jul 19 10:00:51 2001
// Modified at:   Thu Jul 19 14:53:50 2001
// 
// License:
// 
// The contents of this file are subject to the Jabber Open Source
// License Version 1.0 (the License). You may not copy or use this
// file, in either source code or executable form, except in compliance
// with the License. You may obtain a copy of the License at
// http://www.jabber.com/license/ or at http://www.opensource.org/.
// 
// Software distributed under the License is distributed on an AS IS
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the License for the specific language governing rights and limitations
// under the License.
// 
// Copyrights:
// 
// Copyright (c) 1999-2001 Jabber.com
// 
// 
// $Id: CondVariable.cpp,v 1.1 2001/12/16 20:02:26 dr_pepper Exp $
//============================================================================
#include "bedrock.h"
using namespace bedrock;

CondVariable::CondVariable(Mutex& m)
    : _mutex(m)
{
    pthread_cond_init(&_condition, NULL);
}

CondVariable::~CondVariable()
{
    abortingCall(pthread_cond_destroy(&_condition));
}

void CondVariable::signal()
{
    pthread_cond_signal(&_condition);
}

void CondVariable::signalAll()
{
    pthread_cond_broadcast(&_condition);
}

void CondVariable::wait()
{
    pthread_cleanup_push(CondVariable::cancellation_cleanup, this);
    pthread_cond_wait(&_condition, _mutex.getNative());
    pthread_cleanup_pop(0);
}

void CondVariable::cancellation_cleanup(void* arg)
{
    CondVariable* c = (CondVariable*)arg;
    c->_mutex.unlock();
}
