//============================================================================
// Project:       Bedrock -- Foundational Objects
// Filename:      bedrock.cpp
// Description:   bedrock namespace level functions
// Created at:    Wed Aug  1 21:49:52 2001
// Modified at:   Wed Aug  1 21:53:12 2001
// 
// License:
// 
// The contents of this file are subject to the Jabber Open Source
// License Version 1.0 (the License). You may not copy or use this
// file, in either source code or executable form, except in compliance
// with the License. You may obtain a copy of the License at
// http://www.jabber.com/license/ or at http://www.opensource.org/.
// 
// Software distributed under the License is distributed on an AS IS
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the License for the specific language governing rights and limitations
// under the License.
// 
// Copyrights:
// 
// Copyright (c) 1999-2001 Jabber.com
// 
// 
// $Id: bedrock.cpp,v 1.1 2001/12/16 20:02:26 dr_pepper Exp $
//============================================================================
#include "bedrock.h"
using namespace bedrock;
using namespace std;

string bedrock::getTimeStamp(time_t t)
{
    struct tm new_time;
    char buf[18];
    
    if(t == (time_t)-1)
    {
        return string("");
    }

    gmtime_r(&t, &new_time);
    
    snprintf(buf, 18, "%d%02d%02dT%02d:%02d:%02d", 1900+new_time.tm_year,
	     new_time.tm_mon+1, new_time.tm_mday, new_time.tm_hour,
	     new_time.tm_min, new_time.tm_sec);
    
    return string(buf);
}    
string bedrock::getTimeStamp()
{
    return getTimeStamp(time(NULL));
}

